GNU bug report logs - #13355
Deprecating and removing the 'mkinstalldir' script

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: automake; Severity: wishlist; Reported by: Stefano Lattarini <stefano.lattarini@HIDDEN>; dated Fri, 4 Jan 2013 10:16:01 UTC; Maintainer for automake is bug-automake@HIDDEN.

Message received at 13355 <at> debbugs.gnu.org:


Received: (at 13355) by debbugs.gnu.org; 13 Jan 2013 20:52:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 13 15:52:12 2013
Received: from localhost ([127.0.0.1]:58698 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TuUXM-0002vf-B7
	for submit <at> debbugs.gnu.org; Sun, 13 Jan 2013 15:52:12 -0500
Received: from mail-ee0-f42.google.com ([74.125.83.42]:61708)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1TuUXJ-0002vR-Lh
	for 13355 <at> debbugs.gnu.org; Sun, 13 Jan 2013 15:52:10 -0500
Received: by mail-ee0-f42.google.com with SMTP id b47so1252123eek.1
	for <13355 <at> debbugs.gnu.org>; Sun, 13 Jan 2013 12:51:44 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:message-id:date:from:mime-version:to:subject:references
	:in-reply-to:content-type:content-transfer-encoding;
	bh=Htqi3La614RvXCUjBEjWwWyIS3DrMe+sExE8ji9gqJ8=;
	b=a4logWFiiT8kb5tig/Qoe1uc9t1gzgG0XNhz8+oVFxIxVhqz46xiGBaQEGSzCP3BOP
	+P0XHh4N+kRpPxAPS8JzAQUr40vqCFo6FLxTlsGpN4NQu9Nl6iXyFTv3mbY/NEQTqWZ1
	2vW80LfrwINZ8upvO6ZHfmglRIoqsKSqEWvqMcX1Hj4SKTQwzc485EOSxIGi9wJgyR2E
	jWThX/9beoF705w2WWUIKjaOPaudC/L4tctiQJGSn3k+WgZbQWLv+HWWD3MFPkWlMDQE
	REWYgxs9FTjJAY29NvtYIFQZIfPB/BuBn70SYKYBMb4/jJBNw8Y3ODusk1NQrQmdw7Cr
	IJug==
X-Received: by 10.14.205.199 with SMTP id j47mr222841330eeo.26.1358110303909; 
	Sun, 13 Jan 2013 12:51:43 -0800 (PST)
Received: from [192.168.178.21]
	(host137-94-dynamic.4-87-r.retail.telecomitalia.it. [87.4.94.137])
	by mx.google.com with ESMTPS id w3sm18953652eel.17.2013.01.13.12.51.41
	(version=TLSv1 cipher=ECDHE-RSA-RC4-SHA bits=128/128);
	Sun, 13 Jan 2013 12:51:43 -0800 (PST)
Message-ID: <50F31E5B.6020403@HIDDEN>
Date: Sun, 13 Jan 2013 21:51:39 +0100
From: Stefano Lattarini <stefano.lattarini@HIDDEN>
MIME-Version: 1.0
To: 13355 <at> debbugs.gnu.org
Subject: Re: bug#13355: Deprecating and removing the 'mkinstalldir' script
References: <50E6ABC1.5080701@HIDDEN> <50F1C912.5080508@HIDDEN>
In-Reply-To: <50F1C912.5080508@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 13355
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

On 01/12/2013 09:35 PM, Stefano Lattarini wrote:
> On 01/04/2013 11:15 AM, Stefano Lattarini wrote:
>> Severity: wishlist
>>
>> The 'mksintalldirs' script has been by long superseded by "install-sh -d",
>> has  already deprecated in the documentation, and already removed in
>> Automake-NG.  I'd like to remove it in future Automake versions.
>>
>> However, we must first find a viable way to non-fatally deprecate it
>> with some form of runtime warning.
>>
> Here is a tentative roadmap:
> 
> For Automake 1.13.x:
> 
>   - edit 'mkinstalldirs' print a non-fatal warning when invoked (keeping
>     its behaviour unchanged in every other aspect); this warning should
>     reference the use of "install-sh -d".
>
Actually, I'm no longer sure there is a point in mangling a working script
with warnings of dubious usefulness.  A warning at Automake runtime should
be good enough.  Speaking of which ...

>   - have automake print a warning in the 'obsolete' category when it
>     decides to distribute the 'mkinstalldirs' script only because it
>     is found in the AC_CONFIG_AUX_DIR directory (but *not* if the user
>     distributes it explicitly, by listing it in EXTRA_DIST).
>
... this is isn't the truly correct path to deprecation.  A better and
simpler one would be to warn only if 'mkinstalldirs' is *not* listen in
an explicit AC_REQUIRE_AUX_FILE call (which is *the* correct and documented
interface to require auxiliary scripts in Autotools-based projects).

I'll try to cook up a patch along that line (it should be really easy and
minimal at this point).

> For Automake 1.14, or even 1.15:
> 
>   - turn both the warnings above into fatal errors.
>
Now, s/both the warnings/the warning/ of course.

> For the next major version after that:
> 
>   - remove the mkinstalldir script from our Git repository altogether,
>     and drop any special handling of it from the automake script.
>
This stands.

> This will allow anyone using older Automake versions to still be compatible
> with 1.13.2, 1.14 and 1.15 by simply:
> 
>   - committing a copy of 'mkinstalldirs' in his repository;
>
This stands too.

>   - explicitly distributing it by having it listed in EXTRA_DIST.
>
Rather, 'mkinstalldirs' should just be given in a AC_REQUIRE_AUX_FILE
invocation.  This sounds more natural, and is the correct use of APIs.

Regards,
  Stefano




Information forwarded to bug-automake@HIDDEN:
bug#13355; Package automake. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Jan 2013 20:36:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 12 15:36:16 2013
Received: from localhost ([127.0.0.1]:57279 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tu7oO-0000hY-2N
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 15:36:16 -0500
Received: from eggs.gnu.org ([208.118.235.92]:37458)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tu7oL-0000hH-O0
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 15:36:14 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tu7nx-00062t-Jx
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 15:35:54 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-102.6 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_LOW, T_DKIM_INVALID,
	USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:55074)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tu7nx-00062n-DB
	for submit <at> debbugs.gnu.org; Sat, 12 Jan 2013 15:35:49 -0500
Received: from eggs.gnu.org ([208.118.235.92]:48808)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tu7ns-0004e5-WD
	for bug-automake@HIDDEN; Sat, 12 Jan 2013 15:35:49 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tu7nm-000601-1o
	for bug-automake@HIDDEN; Sat, 12 Jan 2013 15:35:44 -0500
Received: from mail-ee0-f50.google.com ([74.125.83.50]:56354)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tu7nl-0005zr-QR
	for bug-automake@HIDDEN; Sat, 12 Jan 2013 15:35:37 -0500
Received: by mail-ee0-f50.google.com with SMTP id e51so674805eek.37
	for <bug-automake@HIDDEN>; Sat, 12 Jan 2013 12:35:37 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:message-id:date:from:mime-version:to:subject:references
	:in-reply-to:content-type:content-transfer-encoding;
	bh=hVYIVS34auEvh3wivuj0nsp/vavnLD2jyjvaJsjyQ0Q=;
	b=SDZ1AQNtkpprTR0z0wVj/qOYVOWFpQXF2uussiz/seA2RhN4OIUs/SUURm15ETInSo
	nYVxzd8IvFqsITBz/CjCk9az4rbfChGRsCTU3oY5b7OJCUS79a81Q3fsTor9k+6JPlTp
	G1uVcmJgbOHGJ2UMfB+BSBSpXh7oWhDXIy+oUJDJ1gl4HMF9IxyNTYMeZl7n523GY8a2
	gwBwvdrOxZ8VoJ3QX8UxNlYTdMPsSFXww/++jytjfwUMbaqCKg/rQ2fSh5EBZbEJbKPv
	i0KXbRrTdnGkjPV5MY+NT7cNfaTh+iE9ucCDwparD/xzq38u9KeXBaUodfKzeMrAd+Nb
	saOw==
X-Received: by 10.14.205.199 with SMTP id j47mr212949079eeo.26.1358022936997; 
	Sat, 12 Jan 2013 12:35:36 -0800 (PST)
Received: from [192.168.178.21]
	(host137-94-dynamic.4-87-r.retail.telecomitalia.it. [87.4.94.137])
	by mx.google.com with ESMTPS id 46sm14315760eeg.4.2013.01.12.12.35.35
	(version=TLSv1 cipher=ECDHE-RSA-RC4-SHA bits=128/128);
	Sat, 12 Jan 2013 12:35:36 -0800 (PST)
Message-ID: <50F1C912.5080508@HIDDEN>
Date: Sat, 12 Jan 2013 21:35:30 +0100
From: Stefano Lattarini <stefano.lattarini@HIDDEN>
MIME-Version: 1.0
To: bug-automake@HIDDEN
Subject: Re: Deprecating and removing the 'mkinstalldir' script
References: <50E6ABC1.5080701@HIDDEN>
In-Reply-To: <50E6ABC1.5080701@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 7bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -3.4 (---)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.4 (---)

On 01/04/2013 11:15 AM, Stefano Lattarini wrote:
> Severity: wishlist
> 
> The 'mksintalldirs' script has been by long superseded by "install-sh -d",
> has  already deprecated in the documentation, and already removed in
> Automake-NG.  I'd like to remove it in future Automake versions.
> 
> However, we must first find a viable way to non-fatally deprecate it
> with some form of runtime warning.
>
Here is a tentative roadmap:

For Automake 1.13.x:

  - edit 'mkinstalldirs' print a non-fatal warning when invoked (keeping
    its behaviour unchanged in every other aspect); this warning should
    reference the use of "install-sh -d".

  - have automake print a warning in the 'obsolete' category when it
    decides to distribute the 'mkinstalldirs' script only because it
    is found in the AC_CONFIG_AUX_DIR directory (but *not* if the user
    distributes it explicitly, by listing it in EXTRA_DIST).

For Automake 1.14, or even 1.15:

  - turn both the warnings above into fatal errors.

For the next major version after that:

  - remove the mkinstalldir script from our Git repository altogether,
    and drop any special handling of it from the automake script.

This will allow anyone using older Automake versions to still be compatible
with 1.13.2, 1.14 and 1.15 by simply:

  - committing a copy of 'mkinstalldirs' in his repository;
  - explicitly distributing it by having it listed in EXTRA_DIST.

This is quite low priority, so it might be some time before any actual
patches materializes.

Regards,
  Stefano




Information forwarded to bug-automake@HIDDEN:
bug#13355; Package automake. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 4 Jan 2013 10:15:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 04 05:15:54 2013
Received: from localhost ([127.0.0.1]:42678 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tr4Jd-0001n3-P6
	for submit <at> debbugs.gnu.org; Fri, 04 Jan 2013 05:15:53 -0500
Received: from eggs.gnu.org ([208.118.235.92]:45261)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tr4Ja-0001mv-8L
	for submit <at> debbugs.gnu.org; Fri, 04 Jan 2013 05:15:51 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tr4JS-0001Un-Ne
	for submit <at> debbugs.gnu.org; Fri, 04 Jan 2013 05:15:43 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-102.6 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_LOW, T_DKIM_INVALID,
	USER_IN_WHITELIST autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:37954)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tr4JS-0001Uh-C6
	for submit <at> debbugs.gnu.org; Fri, 04 Jan 2013 05:15:42 -0500
Received: from eggs.gnu.org ([208.118.235.92]:56616)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tr4JQ-00018m-Lx
	for bug-automake@HIDDEN; Fri, 04 Jan 2013 05:15:42 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tr4JP-0001UG-P2
	for bug-automake@HIDDEN; Fri, 04 Jan 2013 05:15:40 -0500
Received: from mail-la0-f47.google.com ([209.85.215.47]:53501)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stefano.lattarini@HIDDEN>) id 1Tr4JP-0001U2-Hd
	for bug-automake@HIDDEN; Fri, 04 Jan 2013 05:15:39 -0500
Received: by mail-la0-f47.google.com with SMTP id fh20so9286561lab.20
	for <bug-automake@HIDDEN>; Fri, 04 Jan 2013 02:15:38 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:message-id:date:from:mime-version:to:subject
	:content-type:content-transfer-encoding;
	bh=fvnSA4KsyRv3j+7yqtH5h2cI84TlKgjJsQtU8WAwrUw=;
	b=QKLoWPGKj4xPvSpN30Q9Q7fFz13szqueXquighVNjM1ejkJ2B0jHKZVhFnJsKQIPuA
	Rj/huE2nFnkZ8jW2stakut7MPriBUzhm7Bycbhbj6SK1IzlhiZGVe/wYeVTLxs2gPxw5
	Z018l/7M3iwTALkoLjJcynBJXZ/8348rWgIg4jMZlhKBbFzGJq2bvIjMlGAOB4hqLkJ4
	mC8mS7xpaEr4xUe/qBmcDynOs8Teq6KAeZz4kbNsnNukIzZdDxd7eO4/1GMNncolWUAv
	fiQTNQTxw9+s3bPRsPSluXS5ybcSx3CU+OPx3qS+comDUj2WLtYRpzWMJ3bxIpgVdkBt
	nS6Q==
X-Received: by 10.112.9.104 with SMTP id y8mr21115889lba.89.1357294538415;
	Fri, 04 Jan 2013 02:15:38 -0800 (PST)
Received: from [192.168.178.21]
	(host137-94-dynamic.4-87-r.retail.telecomitalia.it. [87.4.94.137])
	by mx.google.com with ESMTPS id t3sm17767976lbl.17.2013.01.04.02.15.36
	(version=SSLv3 cipher=OTHER); Fri, 04 Jan 2013 02:15:37 -0800 (PST)
Message-ID: <50E6ABC1.5080701@HIDDEN>
Date: Fri, 04 Jan 2013 11:15:29 +0100
From: Stefano Lattarini <stefano.lattarini@HIDDEN>
MIME-Version: 1.0
To: bug-automake@HIDDEN
Subject: Deprecating and removing the 'mkinstalldir' script
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 7bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -3.4 (---)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

Severity: wishlist

The 'mksintalldirs' script has been by long superseded by "install-sh -d",
has  already deprecated in the documentation, and already removed in
AUtomake-NG.  I'd like to remove it in future Automake versions.

However, we must first find a viable way to non-fatally deprecate it
with some form of runtime warning.  I haven't yet thought in any detail
about how that; I'm just opening this report to ensure the question
won't slip through the cracks.

Regards,
  Stefano




Acknowledgement sent to Stefano Lattarini <stefano.lattarini@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-automake@HIDDEN. Full text available.
Report forwarded to bug-automake@HIDDEN:
bug#13355; Package automake. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.